"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActionExpectationError = exports.SocketCommandError = void 0;
class SocketCommandError {
    constructor(command, message, payload) {
        this.command = command;
        this.message = message;
        this.payload = payload;
    }
    static CreateFromDatabaseError(command, err) {
        let payload = undefined;
        let message = err.toString();
        if (err.message && typeof err.message === 'string' && err.message.startsWith('json ')) {
            payload = JSON.parse(err.message.substring(5));
            message = undefined;
        }
        return new SocketCommandError(command, message, payload);
    }
}
exports.SocketCommandError = SocketCommandError;
class ActionExpectationError {
    constructor(message, payload, error = 'Expectation Failed', statusCode = 417) {
        this.message = message;
        this.payload = payload;
        this.error = error;
        this.statusCode = statusCode;
    }
    static CreateFromErrorCode(codes) {
        const payload = {};
        payload.codes = codes;
        return new ActionExpectationError(undefined, payload);
    }
    static CreateFromDatabaseError(err) {
        let payload = undefined;
        let message = err.toString();
        if (err.message && typeof err.message === 'string' && err.message.startsWith('json ')) {
            payload = JSON.parse(err.message.substring(5));
            message = undefined;
        }
        return new ActionExpectationError(message, payload);
    }
}
exports.ActionExpectationError = ActionExpectationError;
//# sourceMappingURL=error.model.js.map