import { HttpServer } from './services/http-server';
import { DataService } from './services/data-service';
import { WebSocketService } from './services/websocket-service';
import { Model, QueryBuilder, EventListener } from './services/interfaces';
export declare class Server {
    private dataService;
    private httpServer;
    private webSocketService;
    run(host?: string, port?: number, logger?: boolean, origin?: boolean, socketHost?: string, socketPort?: number): Promise<void>;
    getDataService(): DataService;
    getHttpServer(): HttpServer;
    getWebSocketService(): WebSocketService;
    registerQueryBuilder(queryBuilders: QueryBuilder[]): void;
    registerModel(models: Model[]): void;
    regsiterEventListener(listener: EventListener): void;
    stop(): Promise<void>;
}
