"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isValidDate = exports.uniqueField = void 0;
const change_case_1 = require("change-case");
const http_errors_1 = require("http-errors");
const sql = require("sql-bricks-postgres");
const value_validators_1 = require("./value-validators");
function uniqueField(client, tableName, idField, uniqueField, idValue, uniqueFieldValue, fieldTranslation, err) {
    return __awaiter(this, void 0, void 0, function* () {
        let select = sql.select(idField);
        select = select.from(tableName);
        if (Array.isArray(idField)) {
            if (!Array.isArray(idValue)) {
                throw `idValue should be array as idField is an array.`;
            }
            if (idValue.length !== idField.length) {
                throw `idValue lenght should be ${idValue.length} but it is ${idField.length}`;
            }
            idField.forEach((idf, i) => {
                select = select.where(sql.notEq(idf, idValue[i]));
            });
        }
        else {
            select = select.where(sql.notEq(idField, idValue));
        }
        if (Array.isArray(uniqueField)) {
            if (!Array.isArray(uniqueFieldValue)) {
                throw `uniqueFieldValue should be array as uniqueField is an array.`;
            }
            if (uniqueFieldValue.length !== uniqueField.length) {
                throw `uniqueFieldValue lenght should be ${uniqueFieldValue.length} but it is ${uniqueField.length}`;
            }
            uniqueField.forEach((uf, i) => {
                select = select.where(sql.eq(uf, uniqueFieldValue[i]));
            });
        }
        else {
            select = select.where(sql.eq(uniqueField, uniqueFieldValue));
        }
        select = select.limit('1');
        const rr = yield client.query(select.toParams());
        // const rr = await client.query({
        //   text:`select ${idField} from ${tableName} where ${uniqueField} = $2 and id != $1 limit 1`,
        //   values: [idValue, uniqueFieldValue]
        // });
        if (rr && rr.rows.length > 0) {
            if (Array.isArray(uniqueField)) {
                const fields = uniqueField.map(uf => change_case_1.camelCase(uf));
                const payload = { codes: {} };
                fields.forEach(field => {
                    payload.codes[field] = [{ code: 'duplicate', params: { field: fieldTranslation } }];
                    payload[field] = [`${field} already defined!`];
                });
                const error = new http_errors_1.Conflict(JSON.stringify(payload));
                throw error;
            }
            else {
                const field = change_case_1.camelCase(uniqueField);
                if (err) {
                    err.push(value_validators_1.createError(field, 'duplicate', `${field} already defined!`, { field: fieldTranslation }));
                }
                else {
                    const error = new http_errors_1.Conflict(JSON.stringify({
                        codes: { [field]: [{ code: 'duplicate', params: { field: fieldTranslation } }] },
                        [field]: [`${field} already defined!`],
                    }));
                    throw error;
                }
            }
        }
    });
}
exports.uniqueField = uniqueField;
function isValidDate(d) {
    return d instanceof Date && !isNaN(d.getTime());
}
exports.isValidDate = isValidDate;
//# sourceMappingURL=data-validators.js.map